﻿Type=Class
Version=2.71
@EndOfDesignText@
'Search ver. 1.0
Sub Class_Globals
Private mymodule As Object
'Private SRoot As String
Private Phrase As String
Private isexact, iscase As Boolean
End Sub

'Initializes the object.Put [Me] in the calling module.
Public Sub Initialize(Module As Object)
mymodule = Module

End Sub

'Searches the Root folder for Text string. Put Exact True for Text as the filename, or False for Text contained in the filename.
'Do not start the search (Root) with "/", but something like "sdcard" or "/mnt"
Public Sub Search(Root As String, Text As String, Exact As Boolean, CaseSensitive As Boolean) 
	isexact = Exact
	iscase  = CaseSensitive
	If iscase Then Phrase = Text Else Phrase = Text.ToLowerCase
	CallSub2(mymodule,"Search_Results",Find(Root))
End Sub


Private Sub Find(start As String) As List
Dim list1, list2 As List
Dim fname As String
list2.Initialize
list1 = File.ListFiles(start)
If list1.IsInitialized Then
	For i = 0 To list1.Size-1
		fname = list1.Get(i)
		If File.IsDirectory(start,fname) Then
			Dim list3 As List
			list3 = Find(start & "/" & fname)
			If list3.Size > 0 Then
				For j = 0 To list3.Size - 1
					list2.Add(list3.Get(j))
				Next
			End If
		Else
			If isexact Then
				If iscase Then 
					If fname = Phrase Then list2.Add(start & "/" & fname)
				Else
					If fname.EqualsIgnoreCase(Phrase) Then list2.Add(start & "/" & fname)
				End If
			Else
				If iscase Then 
					If fname.Contains(Phrase) Then	list2.Add(start & "/" & fname)
				Else
					If fname.ToLowerCase.Contains(Phrase) Then	list2.Add(start & "/" & fname)
				End If
			End If
		End If
	Next
End If
Return list2
End Sub